unit dOPCConditionStateDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, dOPCAE, ComCtrls, ExtCtrls, ImgList;

type
  TConditionStateDlg = class(TForm)
    ListView1: TListView;
    Panel1: TPanel;
    bClose: TButton;
    ListView2: TListView;
    ImageList1: TImageList;
    Panel2: TPanel;
    Label1: TLabel;
    eSource: TEdit;
    Label7: TLabel;
    eLAck: TEdit;
    Label2: TLabel;
    eCondition: TEdit;
    Label9: TLabel;
    eLCondition: TEdit;
    Label4: TLabel;
    eQuality: TEdit;
    Label8: TLabel;
    eLSubcondition: TEdit;
    Label5: TLabel;
    eAcknowledger: TEdit;
    Label10: TLabel;
    eLInactive: TEdit;
    Label6: TLabel;
    eAckComment: TEdit;
    cActive: TCheckBox;
    cEnabled: TCheckBox;
    cAcknowledged: TCheckBox;
    procedure FormShow(Sender: TObject);
  private
    Conditionstate: tdOPCEventCondition;
  public
  end;

procedure ShowConditionState(Conditionstate: tdOPCEventCondition);

implementation

{$R *.DFM}

procedure ShowConditionState(Conditionstate: tdOPCEventCondition);
var
  D : TConditionStateDlg;
begin
 if Conditionstate = nil then exit;
 Application.CreateForm(TConditionStateDlg,D);
 D.Conditionstate := Conditionstate;
 try
   D.ShowModal();
 finally
   D.free();
 end;
end;

procedure SetDate(Edit: TEdit; aDate: TDateTime);
begin
 if aDate <> 0 then
   Edit.Text         := DateTimeToStr(aDate)
 else
   Edit.Text := 'unknown';
end;

procedure TConditionStateDlg.FormShow(Sender: TObject);
var
 SubCondition: tdOPCEventSubcondition;
 Item  : TListItem;
 i : integer;
begin

    with Conditionstate do
    begin
       eSource.Text       := Source;
       eCondition.Text    := ConditionName;
       eAcknowledger.Text := AcknowledgerID;
       eAckComment.Text   := Comment;
       SetDate(eLAck,LastAckTime);
       SetDate(eLCondition,CondLastActive);
       SetDate(eLSubcondition,SubCondLastActive);
       SetDate(eLInactive,CondLastInactive);
       eQuality.Text      := 'Bad';
       if IsGoodQuality then
         eQuality.Text    := 'Good';
       cActive.Checked    := Active;
       cEnabled.Checked   := Enabled;
       cAcknowledged.Checked := Acknowledged;
       ListView1.Items.BeginUpdate;
       ListView1.Items.Clear;
       for i := 0 to SubConditions.Count-1 do
       begin
         SubCondition := SubConditions[i];
         Item := ListView1.Items.Add;                    // add new view item
         Item.Caption := SubCondition.Name;
         Item.SubItems.Add(SubCondition.Definition);
         Item.SubItems.Add(SubCondition.Description);
         Item.SubItems.Add(IntToStr(SubCondition.Severity));
         Item.ImageIndex := -1;
         if ActiveSubCondition = i then
           Item.ImageIndex := 0;
       end;
       ListView1.Items.EndUpdate;

       ListView2.Items.BeginUpdate;
       ListView2.Items.Clear;
       for i := 0 to CustomProps.Count-1 do
       begin
         Item := ListView2.Items.Add;                    // add new view item
         Item.Caption := CustomProps.Names[i];
         Item.SubItems.Add(CustomProps.ValueAsString[i]);
         Item.SubItems.Add(IntToStr(CustomProps.Errors[i]));
       end;
       ListView2.Items.EndUpdate;
    end;
end;

end.
